' ChkLimitActive
'            tech-project / nuenaka@square-enix.co.jp

function XSILoadPlugin( in_reg )
	in_reg.Author = "Nuenaka"
	in_reg.Name = "ChkLimitActive Plug-in"
	in_reg.Major = 1
	in_reg.Minor = 2
	in_reg.RegisterCommand "ChkLimitActive","ChkLimitActive"
	XSILoadPlugin = true
end function

'----------------------------------------------------------------------
function ChkLimitActive_Init( io_Context )
	dim oCmd
	set oCmd = io_Context.Source
'	Application.LogMessage "ChkLimitActive_Init called"
	oCmd.Description = "Check LimitPos&Rot are active or not."
	oCmd.ToolTip = ""
	oCmd.SetFlag siSupportsKeyAssignment
	oCmd.ReturnValue = true
	ChkLimitActive_Init = true
end function

'----------------------------------------------------------------------
function ChkLimitActive_Execute(  )
'	Application.LogMessage "ChkLimitActive_Execute called"

	dim tpc
	tpc = TechPluginCertification( "ChkLimitActive", "1.1" )
	if tpc <> True then
		' false ɂƗvȂG[bZ[Wô true ƂB
		ChkLimitActive_Execute = true
        exit function
	end if


	dim oProp
	set oProp = ActiveSceneRoot.AddProperty("ChkLimitActiveDlg")

	On Error Resume Next
	InspectObj oProp, "", "Please select check target.", siModal

	if Err.Number = 0 then
		ChkLimitActive_Execute2( oProp )
'	else
'		LogMessage "Cancel"
	end if
	DeleteObj oProp
	ChkLimitActive_Execute = true
end function

'----------------------------------------------------------------------
function addObjs( objs, oObj )
    for each s in objs
        if s = oObj then
            exit function
        end if
    next
    objs.add oObj
end function

'----------------------------------------------------------------------
function ChkLimitActive_Execute2( oProp )
    if selection.Count = 0 then
        logmessage "Please select object(s)."
        exit function
    end if

	SelectChildNodes

    dim objs
    set objs = CreateObject( "XSI.Collection" )
    dim oObj
    for each oObj in selection
		ChkLimitActiveOne oProp, objs, oObj
    next
	

	if GetValue( "ChkLimitActiveDlg.SelectOrNoSelect" ) = 0 then
	    SelectObj objs
	else
		ToggleSelection objs
	end if

end function

'----------------------------------------------------------------------
function ChkLimitActiveOne2( objs, oObj, propname, chkname )
	if GetValue( "ChkLimitActiveDlg" & propname ) then
		if GetValue( oObj.FullName & ".kine.local" & chkname ) then
			LogMessage oObj.FullName & ".kine.local" & chkname & " is ACTIVE."
			addObjs objs, oObj
		end if
	end if
end function

'----------------------------------------------------------------------
function ChkLimitActiveOne( oProp, objs, oObj )

	ChkLimitActiveOne2 objs, oObj, ".PosMinX", ".posxminactive"
	ChkLimitActiveOne2 objs, oObj, ".PosMinY", ".posyminactive"
	ChkLimitActiveOne2 objs, oObj, ".PosMinZ", ".poszminactive"
	ChkLimitActiveOne2 objs, oObj, ".PosMaxX", ".posxmaxactive"
	ChkLimitActiveOne2 objs, oObj, ".PosMaxY", ".posymaxactive"
	ChkLimitActiveOne2 objs, oObj, ".PosMaxZ", ".poszmaxactive"
	ChkLimitActiveOne2 objs, oObj, ".RotMinX", ".rotxminactive"
	ChkLimitActiveOne2 objs, oObj, ".RotMinY", ".rotyminactive"
	ChkLimitActiveOne2 objs, oObj, ".RotMinZ", ".rotzminactive"
	ChkLimitActiveOne2 objs, oObj, ".RotMaxX", ".rotxmaxactive"
	ChkLimitActiveOne2 objs, oObj, ".RotMaxY", ".rotymaxactive"
	ChkLimitActiveOne2 objs, oObj, ".RotMaxZ", ".rotzmaxactive"

	if ( oObj.type = "bone" ) then
		if GetValue( "ChkLimitActiveDlg.JointRotLim" ) then
			if GetValue( oObj.FullName & ".joint.rotlim_active" ) then
				LogMessage oObj.FullName & ".joint.rotlim_active is ACTIVE."
				addObjs objs, oObj
			end if
		end if
	end if

end function



